#include <stdio.h>
#include <stdlib.h>

#include <wiringPi.h>
#include <wiringSerial.h>
#include <string.h>
#include <lcd.h>
#include <unistd.h>

#define ON 1
#define OFF 0

#define STOP_PIN	26
#define INTERRUPT_PIN	18
#define SERIAL_PORT "/dev/serial0"
#define ONE_LINE 1024
#define MODECHANGE 11

int fd ; // serial id
char oneline[ONE_LINE] ;
int fd_lcd;
char g_ido[128] ;
char g_keido[128] ;
char g_speedbar[32] ;
char g_speedchr[32] ;
int disp_mode = 0 ;	// 0 : speed  1 : lat/lot  2 : time   99 : test

void MySplit(char *ido, char *keido) {
	int counter = 0;
	int onelineLength = strlen(oneline) ;
	char buff[256] ;
	int point = 0 ;
	float value = 0 ;

	int _do ;
	int _hun ;
	int _byou ;
	float amari ;

	memset(buff, 0x00, 256) ;
	for (int i=0;i<onelineLength;i++) {
		if (oneline[i] == ',') {
			switch(point) {
			case 2 :
				// ido
				value = atof(buff) ;
				_do = (int)(value / 100) ;
				_hun = (int)(value - (_do * 100)) ;
				amari = value - _do * 100 - _hun ;
				_byou = (int)(amari * 60) ;
				amari = amari * 60 - (float)_byou ;
				sprintf(ido, "%03d'%02d'%02d'%1d", _do, _hun, _byou, (int)(amari * (float)10)) ;
				sprintf(g_ido, "LAT=%s", ido) ;


				break ;
			case 4 :
				// keido
				value = atof(buff) ;
				_do = (int)(value / 100) ;
				_hun = (int)(value - (_do * 100)) ;
				amari = value - _do * 100 - _hun ;
				_byou = (int)(amari * 60) ;
				amari = amari * 60 - (float)_byou ;
				sprintf(keido, "%03d'%02d'%02d'%1d", _do, _hun, _byou, (int)(amari * (float)10)) ;

				sprintf(g_keido, "LOT=%s", keido) ;

				break ;

			default :
				break ;
			}
			point ++ ;
			memset(buff, 0x00, 256) ;
			counter = 0 ;
			
		} else {
			buff[counter] = oneline[i] ;
			counter ++ ; 
		}
	}


}

void MySplit2(float *direction, float *speed ) {
	int counter = 0;
	int onelineLength = strlen(oneline) ;
	char buff[256] ;
	int point = 0 ;
	float value = 0 ;

	memset(buff, 0x00, 256) ;
	for (int i=0;i<onelineLength;i++) {
		if (oneline[i] == ',') {
			switch(point) {
			case 7 :
				// speed
				value = atof(buff) ;
				*speed = value ;

				// value = 95 ;	

				memset(g_speedbar, 0x00, 32) ;
				if (value >= 10 && value < 20) {
					strcpy(g_speedbar, "*              ") ;
				} else if (value >= 20 && value < 30) {
					strcpy(g_speedbar, "**             ") ;
				} else if (value >= 30 && value < 40) {
					strcpy(g_speedbar, "***            ") ;
				} else if (value >= 40 && value < 50) {
					strcpy(g_speedbar, "****           ") ;
				} else if (value >= 50 && value < 60) {
					strcpy(g_speedbar, "*****          ") ;
				} else if (value >= 60 && value < 70) {
					strcpy(g_speedbar, "******         ") ;
				} else if (value >= 70 && value < 80) {
					strcpy(g_speedbar, "******#        ") ;
				} else if (value >= 80 && value < 90) {
					strcpy(g_speedbar, "******##       ") ;
				} else if (value >= 90 && value < 100) {
					strcpy(g_speedbar, "******##@      ") ;
				} else if (value >= 100 && value < 110) {
					strcpy(g_speedbar, "******##@@     ") ;
				} else if (value >= 110 && value < 120) {
					strcpy(g_speedbar, "******##@@$    ") ;
				} else if (value >= 120 && value < 130) {
					strcpy(g_speedbar, "******##@@$$") ;
				} else if (value >= 130) {
					strcpy(g_speedbar, "- alert speed -") ;
				} else {
					strcpy(g_speedbar, "               ") ;
				} 

				sprintf(g_speedchr, "%3.1f km/h      ", value) ;

				break ;
			
			default :
				break ;
			}
			point ++ ;
			memset(buff, 0x00, 256) ;
			counter = 0 ;
			
		} else {
			buff[counter] = oneline[i] ;
			counter ++ ; 
		}
	}
}

void terminal_display() {
	char ido[128] ;
	char keido[128] ;
	char potbuff[1024] ;

	float direction ;
	float speed ;

	if (strncmp(oneline, "$GPGGA", 6) == 0) {
		MySplit(ido, keido) ;

		sprintf(potbuff, "ido=%s / kei=%s\n", ido, keido) ;
		printf(potbuff) ;

	} else if (strncmp(oneline, "$GPVTG", 6) == 0) {
		MySplit2(&direction, &speed) ;
		
		printf("speed=%f\n", speed) ;
	}

}

void get_gps_data() {
	char buff[1024] ;
	int read_length ;
	int onelinepointer ;

	onelinepointer = strlen(oneline) ;

	read_length = serialDataAvail(fd) ;

	/*  受信データをバッファに入れる */
	for (int i=0;i<read_length;i++) {
		if (i+onelinepointer >= ONE_LINE) {
			break ;
		}
		oneline[onelinepointer] = serialGetchar(fd) ;
		if (oneline[onelinepointer] == 0x0a) { 
			terminal_display() ;
			memset(oneline, 0x00, ONE_LINE) ;
			onelinepointer = 0 ;
		} else {
			onelinepointer++ ;
		}
	}
}

int init() {
	int i = 0 ;

	if (wiringPiSetupGpio() == -1) {
		return -1 ;
	}


	fd = serialOpen(SERIAL_PORT, 9600); 

	if (fd < 0) {
		printf("serial open error\n") ;
		return -1 ;
	}

	pinMode(INTERRUPT_PIN, INPUT) ;
	pullUpDnControl(INTERRUPT_PIN, PUD_UP) ;
	wiringPiISR(INTERRUPT_PIN, INT_EDGE_FALLING, get_gps_data) ;
	waitForInterrupt(INTERRUPT_PIN, 2000) ;

	pinMode(STOP_PIN, INPUT) ;
	pullUpDnControl(STOP_PIN, PUD_UP) ;
	pinMode(MODECHANGE, INPUT) ;
	pullUpDnControl(MODECHANGE, PUD_UP) ;

	memset(oneline, 0x00, ONE_LINE);

	// LCD INIT
	fd_lcd = lcdInit(2,16,4,4,17,27,22,5,6,0,0,0,0);
    	lcdClear(fd_lcd);

	return 1 ;
}

int main(void) {
	char speedbar[16] ;
	int back_readvalue = 0 ;

	if (init() == -1) {
		return 1 ;
	}


	while(digitalRead(STOP_PIN) != 0) {

		int readvalue = digitalRead(MODECHANGE) ;

		if (back_readvalue != readvalue) {
			lcdClear(fd_lcd);
		}

		back_readvalue = readvalue ;

		// printf("readvalue=%d \n", readvalue) ;

		if (readvalue == 0) {
			disp_mode = 0 ;

		} else {
			disp_mode = 1 ;
		}

		switch(disp_mode) {
		case 0 :

			lcdPosition(fd_lcd,0,0);
			lcdPuts(fd_lcd,g_speedbar);
    		lcdPosition(fd_lcd,0,1);
    		lcdPuts(fd_lcd,g_speedchr);

			lcdDisplay(fd_lcd,0);
			lcdDisplay(fd_lcd,1);
		
		break ;

		case 1:
			lcdPosition(fd_lcd,0,0);
			lcdPuts(fd_lcd,g_ido);
			lcdPosition(fd_lcd,0,1);
			lcdPuts(fd_lcd,g_keido);

			lcdDisplay(fd_lcd,0);
			lcdDisplay(fd_lcd,1);

		break ;

		case 99 :
 		break ;

		default :
		break ;

		}

		sleep(1) ;

	}

	printf("Stop !! \n") ;

	serialClose(fd) ;

  	lcdClear(fd_lcd);
	return 1 ;
}

